(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["ReduxFalcor"] = factory(require("react"));
	else
		root["ReduxFalcor"] = factory(root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_2__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _duck = __webpack_require__(1);

	Object.defineProperty(exports, 'reducer', {
	  enumerable: true,
	  get: function get() {
	    return _duck.default;
	  }
	});

	var _FalcorProvider = __webpack_require__(3);

	Object.defineProperty(exports, 'FalcorProvider', {
	  enumerable: true,
	  get: function get() {
	    return _FalcorProvider.default;
	  }
	});

	var _reduxFalcor = __webpack_require__(5);

	Object.defineProperty(exports, 'reduxFalcor', {
	  enumerable: true,
	  get: function get() {
	    return _reduxFalcor.default;
	  }
	});

/***/ },
/* 1 */
/***/ function(module, exports) {

	'use strict';

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = reduxFalcorReducer;
	exports.update = update;
	var UPDATE = 'redux-falcor/UPDATE';

	function reduxFalcorReducer() {
	  var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
	  var action = arguments[1];

	  switch (action.type) {
	    case UPDATE:
	      return _extends({}, action.payload);
	    default:
	      return state;
	  }
	}

	function update(falcorCache) {
	  return {
	    type: UPDATE,
	    payload: falcorCache
	  };
	}

/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _react = __webpack_require__(2);

	var _falcorExpandCache = __webpack_require__(6);

	var _falcorExpandCache2 = _interopRequireDefault(_falcorExpandCache);

	var _createStore = __webpack_require__(4);

	var _createStore2 = _interopRequireDefault(_createStore);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	function debounce(func, wait) {
	  var timeout = undefined;
	  return function doDebounce() {
	    var context = this;
	    var args = arguments;
	    var later = function later() {
	      timeout = null;
	      func.apply(context, args);
	    };
	    clearTimeout(timeout);
	    timeout = setTimeout(later, wait);
	  };
	}

	function attachOnChange(falcor, store) {
	  // TODO: Throttle requests here
	  var handler = debounce(function () {
	    store.trigger((0, _falcorExpandCache2.default)(falcor.getCache()));
	  }, 50);

	  var root = falcor._root;
	  if (!root.onChange) {
	    root.onChange = handler;
	    return;
	  }

	  var oldOnChange = root.onChange;
	  root.onChange = function () {
	    oldOnChange();
	    handler();
	  };
	}

	var FalcorProvider = (function (_Component) {
	  _inherits(FalcorProvider, _Component);

	  function FalcorProvider(props, context) {
	    _classCallCheck(this, FalcorProvider);

	    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(FalcorProvider).call(this, props, context));

	    _this.falcor = props.falcor;
	    _this.falcorStore = (0, _createStore2.default)(props.store);
	    attachOnChange(props.falcor, _this.falcorStore);
	    return _this;
	  }

	  _createClass(FalcorProvider, [{
	    key: 'getChildContext',
	    value: function getChildContext() {
	      return {
	        falcor: this.falcor,
	        falcorStore: this.falcorStore
	      };
	    }
	  }, {
	    key: 'render',
	    value: function render() {
	      var children = this.props.children;

	      return _react.Children.only(children);
	    }
	  }]);

	  return FalcorProvider;
	})(_react.Component);

	FalcorProvider.propTypes = {
	  falcor: _react.PropTypes.object.isRequired,
	  store: _react.PropTypes.object.isRequired,
	  children: _react.PropTypes.element.isRequired
	};
	FalcorProvider.childContextTypes = {
	  falcor: _react.PropTypes.object.isRequired,
	  falcorStore: _react.PropTypes.object.isRequired
	};
	exports.default = FalcorProvider;

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = createStore;

	var _duck = __webpack_require__(1);

	function createStore(reduxStore) {
	  var listeners = [];

	  function subscribe(listener) {
	    listeners.push(listener);
	    var isSubscribed = true;

	    return function unsubscribe() {
	      if (!isSubscribed) return;

	      isSubscribed = false;
	      listeners.splice(listeners.indexOf(listener), 1);
	    };
	  }

	  function trigger(cache) {
	    // Update the redux with the changes
	    reduxStore.dispatch((0, _duck.update)(cache));

	    // Trigger listeners to refetch possible invalidated data
	    listeners.slice().forEach(function (listener) {
	      return listener();
	    });
	    return cache;
	  }

	  return {
	    subscribe: subscribe,
	    trigger: trigger
	  };
	}

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = reduxFalcor;

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _invariant = __webpack_require__(8);

	var _invariant2 = _interopRequireDefault(_invariant);

	var _hoistNonReactStatics = __webpack_require__(7);

	var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	function getDisplayName(WrappedComponent) {
	  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
	}

	function noop() {}

	function reduxFalcor(WrappedComponent) {
	  var ReduxFalcor = (function (_Component) {
	    _inherits(ReduxFalcor, _Component);

	    function ReduxFalcor(props, context) {
	      _classCallCheck(this, ReduxFalcor);

	      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ReduxFalcor).call(this, props, context));

	      _this.falcor = props.falcor || context.falcor;
	      _this.falcorStore = props.falcorStore || context.falcorStore;

	      (0, _invariant2.default)(_this.falcorStore, 'Could not find "falcorStore" in either the context or ' + ('props of "' + _this.constructor.displayName + '". ') + 'Either wrap the root component in a <FalcorProvider>, ' + ('or explicitly pass "falcorStore" as a prop to "' + _this.constructor.displayName + '".'));
	      return _this;
	    }

	    _createClass(ReduxFalcor, [{
	      key: 'componentDidMount',
	      value: function componentDidMount() {
	        this.trySubscribe();
	      }
	    }, {
	      key: 'componentWillUnmount',
	      value: function componentWillUnmount() {
	        this.tryUnsubscribe();
	      }
	    }, {
	      key: 'trySubscribe',
	      value: function trySubscribe() {
	        if (!this.unsubscribe) {
	          this.unsubscribe = this.falcorStore.subscribe(this.handleChange.bind(this));
	          this.handleChange();
	        }
	      }
	    }, {
	      key: 'handleChange',
	      value: function handleChange() {
	        var wrappedInstance = this.refs.wrappedInstance;

	        if (!this.unsubscribe) return;
	        if (!(typeof wrappedInstance.fetchFalcorDeps === 'function')) return;

	        wrappedInstance.fetchFalcorDeps().then(noop);
	      }
	    }, {
	      key: 'tryUnsubscribe',
	      value: function tryUnsubscribe() {
	        if (this.unsubscribe) {
	          this.unsubscribe();
	          this.unsubscribe = null;
	        }
	      }
	    }, {
	      key: 'render',
	      value: function render() {
	        return _react2.default.createElement(WrappedComponent, _extends({}, this.props, {
	          falcor: this.falcor,
	          ref: 'wrappedInstance'
	        }));
	      }
	    }]);

	    return ReduxFalcor;
	  })(_react.Component);

	  ReduxFalcor.displayName = 'ReduxFalcor(' + getDisplayName(WrappedComponent) + ')';
	  ReduxFalcor.WrappedComponent = WrappedComponent;

	  ReduxFalcor.propTypes = {
	    falcorStore: _react.PropTypes.object,
	    falcor: _react.PropTypes.object
	  };

	  ReduxFalcor.contextTypes = {
	    falcorStore: _react.PropTypes.object.isRequired,
	    falcor: _react.PropTypes.object.isRequired
	  };

	  return (0, _hoistNonReactStatics2.default)(ReduxFalcor, WrappedComponent);
	}

/***/ },
/* 6 */
/***/ function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports.default = expandCache;
	function expandCache(cache) {
	  function followPath(path) {
	    return path.reduce(function (acc, part) {
	      if (acc && acc[part]) {
	        return acc[part];
	      }

	      return undefined;
	    }, cache);
	  }

	  function expandChild(child) {
	    if (child.$type === 'atom') return child.value;
	    if (child.$type === 'ref') return createNode(followPath(child.value));
	    if (child.$type === 'error') return new Error(child.value);
	    // Unknown Sentinel
	    if (child.$type) return undefined;

	    return createNode(child);
	  }

	  function createNode(data) {
	    if (!data) return undefined;
	    if (data.$type) return expandChild(data);
	    var node = {};
	    var nodeCache = {};

	    Object.keys(data).forEach(function (key) {
	      Object.defineProperty(node, key, {
	        enumerable: true,
	        get: function get() {
	          if (key in nodeCache) {
	            return nodeCache[key];
	          }

	          nodeCache[key] = expandChild(data[key]);
	          return nodeCache[key];
	        }
	      });
	    });

	    return node;
	  }

	  return createNode(cache);
	}

/***/ },
/* 7 */
/***/ function(module, exports) {

	/**
	 * Copyright 2015, Yahoo! Inc.
	 * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
	 */
	'use strict';

	var REACT_STATICS = {
	    childContextTypes: true,
	    contextTypes: true,
	    defaultProps: true,
	    displayName: true,
	    getDefaultProps: true,
	    mixins: true,
	    propTypes: true,
	    type: true
	};

	var KNOWN_STATICS = {
	    name: true,
	    length: true,
	    prototype: true,
	    caller: true,
	    arguments: true,
	    arity: true
	};

	module.exports = function hoistNonReactStatics(targetComponent, sourceComponent) {
	    var keys = Object.getOwnPropertyNames(sourceComponent);
	    for (var i=0; i<keys.length; ++i) {
	        if (!REACT_STATICS[keys[i]] && !KNOWN_STATICS[keys[i]]) {
	            targetComponent[keys[i]] = sourceComponent[keys[i]];
	        }
	    }

	    return targetComponent;
	};


/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {/**
	 * Copyright 2013-2015, Facebook, Inc.
	 * All rights reserved.
	 *
	 * This source code is licensed under the BSD-style license found in the
	 * LICENSE file in the root directory of this source tree. An additional grant
	 * of patent rights can be found in the PATENTS file in the same directory.
	 */

	'use strict';

	/**
	 * Use invariant() to assert state which your program assumes to be true.
	 *
	 * Provide sprintf-style format (only %s is supported) and arguments
	 * to provide information about what broke and what you were
	 * expecting.
	 *
	 * The invariant message will be stripped in production, but the invariant
	 * will remain to ensure logic does not differ in production.
	 */

	var invariant = function(condition, format, a, b, c, d, e, f) {
	  if (process.env.NODE_ENV !== 'production') {
	    if (format === undefined) {
	      throw new Error('invariant requires an error message argument');
	    }
	  }

	  if (!condition) {
	    var error;
	    if (format === undefined) {
	      error = new Error(
	        'Minified exception occurred; use the non-minified dev environment ' +
	        'for the full error message and additional helpful warnings.'
	      );
	    } else {
	      var args = [a, b, c, d, e, f];
	      var argIndex = 0;
	      error = new Error(
	        format.replace(/%s/g, function() { return args[argIndex++]; })
	      );
	      error.name = 'Invariant Violation';
	    }

	    error.framesToPop = 1; // we don't care about invariant's own frame
	    throw error;
	  }
	};

	module.exports = invariant;

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(9)))

/***/ },
/* 9 */
/***/ function(module, exports) {

	// shim for using process in browser

	var process = module.exports = {};
	var queue = [];
	var draining = false;
	var currentQueue;
	var queueIndex = -1;

	function cleanUpNextTick() {
	    draining = false;
	    if (currentQueue.length) {
	        queue = currentQueue.concat(queue);
	    } else {
	        queueIndex = -1;
	    }
	    if (queue.length) {
	        drainQueue();
	    }
	}

	function drainQueue() {
	    if (draining) {
	        return;
	    }
	    var timeout = setTimeout(cleanUpNextTick);
	    draining = true;

	    var len = queue.length;
	    while(len) {
	        currentQueue = queue;
	        queue = [];
	        while (++queueIndex < len) {
	            if (currentQueue) {
	                currentQueue[queueIndex].run();
	            }
	        }
	        queueIndex = -1;
	        len = queue.length;
	    }
	    currentQueue = null;
	    draining = false;
	    clearTimeout(timeout);
	}

	process.nextTick = function (fun) {
	    var args = new Array(arguments.length - 1);
	    if (arguments.length > 1) {
	        for (var i = 1; i < arguments.length; i++) {
	            args[i - 1] = arguments[i];
	        }
	    }
	    queue.push(new Item(fun, args));
	    if (queue.length === 1 && !draining) {
	        setTimeout(drainQueue, 0);
	    }
	};

	// v8 likes predictible objects
	function Item(fun, array) {
	    this.fun = fun;
	    this.array = array;
	}
	Item.prototype.run = function () {
	    this.fun.apply(null, this.array);
	};
	process.title = 'browser';
	process.browser = true;
	process.env = {};
	process.argv = [];
	process.version = ''; // empty string to avoid regexp issues
	process.versions = {};

	function noop() {}

	process.on = noop;
	process.addListener = noop;
	process.once = noop;
	process.off = noop;
	process.removeListener = noop;
	process.removeAllListeners = noop;
	process.emit = noop;

	process.binding = function (name) {
	    throw new Error('process.binding is not supported');
	};

	process.cwd = function () { return '/' };
	process.chdir = function (dir) {
	    throw new Error('process.chdir is not supported');
	};
	process.umask = function() { return 0; };


/***/ }
/******/ ])
});
;