'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _falcorExpandCache = require('falcor-expand-cache');

var _falcorExpandCache2 = _interopRequireDefault(_falcorExpandCache);

var _createStore = require('./createStore');

var _createStore2 = _interopRequireDefault(_createStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function debounce(func, wait) {
  var timeout = undefined;
  return function doDebounce() {
    var context = this;
    var args = arguments;
    var later = function later() {
      timeout = null;
      func.apply(context, args);
    };
    clearTimeout(timeout);
    timeout = setTimeout(later, wait);
  };
}

function attachOnChange(falcor, store) {
  // TODO: Throttle requests here
  var handler = debounce(function () {
    store.trigger((0, _falcorExpandCache2.default)(falcor.getCache()));
  }, 50);

  var root = falcor._root;
  if (!root.onChange) {
    root.onChange = handler;
    return;
  }

  var oldOnChange = root.onChange;
  root.onChange = function () {
    oldOnChange();
    handler();
  };
}

var FalcorProvider = (function (_Component) {
  _inherits(FalcorProvider, _Component);

  function FalcorProvider(props, context) {
    _classCallCheck(this, FalcorProvider);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(FalcorProvider).call(this, props, context));

    _this.falcor = props.falcor;
    _this.falcorStore = (0, _createStore2.default)(props.store);
    attachOnChange(props.falcor, _this.falcorStore);
    return _this;
  }

  _createClass(FalcorProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        falcor: this.falcor,
        falcorStore: this.falcorStore
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;

      return _react.Children.only(children);
    }
  }]);

  return FalcorProvider;
})(_react.Component);

FalcorProvider.propTypes = {
  falcor: _react.PropTypes.object.isRequired,
  store: _react.PropTypes.object.isRequired,
  children: _react.PropTypes.element.isRequired
};
FalcorProvider.childContextTypes = {
  falcor: _react.PropTypes.object.isRequired,
  falcorStore: _react.PropTypes.object.isRequired
};
exports.default = FalcorProvider;