'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = reduxFalcor;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

function noop() {}

function reduxFalcor(WrappedComponent) {
  var ReduxFalcor = (function (_Component) {
    _inherits(ReduxFalcor, _Component);

    function ReduxFalcor(props, context) {
      _classCallCheck(this, ReduxFalcor);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ReduxFalcor).call(this, props, context));

      _this.falcor = props.falcor || context.falcor;
      _this.falcorStore = props.falcorStore || context.falcorStore;

      (0, _invariant2.default)(_this.falcorStore, 'Could not find "falcorStore" in either the context or ' + ('props of "' + _this.constructor.displayName + '". ') + 'Either wrap the root component in a <FalcorProvider>, ' + ('or explicitly pass "falcorStore" as a prop to "' + _this.constructor.displayName + '".'));
      return _this;
    }

    _createClass(ReduxFalcor, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.trySubscribe();
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.tryUnsubscribe();
      }
    }, {
      key: 'trySubscribe',
      value: function trySubscribe() {
        if (!this.unsubscribe) {
          this.unsubscribe = this.falcorStore.subscribe(this.handleChange.bind(this));
          this.handleChange();
        }
      }
    }, {
      key: 'handleChange',
      value: function handleChange() {
        var wrappedInstance = this.refs.wrappedInstance;

        if (!this.unsubscribe) return;
        if (!(typeof wrappedInstance.fetchFalcorDeps === 'function')) return;

        wrappedInstance.fetchFalcorDeps().then(noop);
      }
    }, {
      key: 'tryUnsubscribe',
      value: function tryUnsubscribe() {
        if (this.unsubscribe) {
          this.unsubscribe();
          this.unsubscribe = null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(WrappedComponent, _extends({}, this.props, {
          falcor: this.falcor,
          ref: 'wrappedInstance'
        }));
      }
    }]);

    return ReduxFalcor;
  })(_react.Component);

  ReduxFalcor.displayName = 'ReduxFalcor(' + getDisplayName(WrappedComponent) + ')';
  ReduxFalcor.WrappedComponent = WrappedComponent;

  ReduxFalcor.propTypes = {
    falcorStore: _react.PropTypes.object,
    falcor: _react.PropTypes.object
  };

  ReduxFalcor.contextTypes = {
    falcorStore: _react.PropTypes.object.isRequired,
    falcor: _react.PropTypes.object.isRequired
  };

  return (0, _hoistNonReactStatics2.default)(ReduxFalcor, WrappedComponent);
}